/**
 * @name array-of-arrays-into-ast
 * @fileoverview Turns an array of arrays of data into a nested tree of plain objects
 * @version 4.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-of-arrays-into-ast/}
 */

"use strict";var arrayOfArraysIntoAst=(()=>{var Rt=Object.create;var P=Object.defineProperty,Lt=Object.defineProperties,Ut=Object.getOwnPropertyDescriptor,Gt=Object.getOwnPropertyDescriptors,Vt=Object.getOwnPropertyNames,Se=Object.getOwnPropertySymbols,Ht=Object.getPrototypeOf,Te=Object.prototype.hasOwnProperty,Wt=Object.prototype.propertyIsEnumerable;var we=(e,t,r)=>t in e?P(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,m=(e,t)=>{for(var r in t||(t={}))Te.call(t,r)&&we(e,r,t[r]);if(Se)for(var r of Se(t))Wt.call(t,r)&&we(e,r,t[r]);return e},U=(e,t)=>Lt(e,Gt(t));var G=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),Jt=(e,t)=>{for(var r in t)P(e,r,{get:t[r],enumerable:!0})},Ee=(e,t,r,n)=>{if(t&&typeof t=="object"||typeof t=="function")for(let o of Vt(t))!Te.call(e,o)&&o!==r&&P(e,o,{get:()=>t[o],enumerable:!(n=Ut(t,o))||n.enumerable});return e};var V=(e,t,r)=>(r=e!=null?Rt(Ht(e)):{},Ee(t||!e||!e.__esModule?P(r,"default",{value:e,enumerable:!0}):r,e)),Qt=e=>Ee(P({},"__esModule",{value:!0}),e);var De=G((Ma,Pe)=>{var Ce=1/0,Me=9007199254740991,qt=17976931348623157e292,$e=0/0,Zt="[object Arguments]",Xt="[object Function]",zt="[object GeneratorFunction]",Yt="[object String]",er="[object Symbol]",tr=/^\s+|\s+$/g,rr=/^[-+]0x[0-9a-f]+$/i,nr=/^0b[01]+$/i,ar=/^0o[0-7]+$/i,ir=/^(?:0|[1-9]\d*)$/,or=parseInt;function sr(e,t){for(var r=-1,n=e?e.length:0,o=Array(n);++r<n;)o[r]=t(e[r],r,e);return o}function cr(e,t,r,n){for(var o=e.length,a=r+(n?1:-1);n?a--:++a<o;)if(t(e[a],a,e))return a;return-1}function ur(e,t,r){if(t!==t)return cr(e,fr,r);for(var n=r-1,o=e.length;++n<o;)if(e[n]===t)return n;return-1}function fr(e){return e!==e}function pr(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function lr(e,t){return sr(t,function(r){return e[r]})}function yr(e,t){return function(r){return e(t(r))}}var H=Object.prototype,ae=H.hasOwnProperty,W=H.toString,hr=H.propertyIsEnumerable,gr=yr(Object.keys,Object),br=Math.max;function dr(e,t){var r=Ie(e)||jr(e)?pr(e.length,String):[],n=r.length,o=!!n;for(var a in e)(t||ae.call(e,a))&&!(o&&(a=="length"||Ar(a,n)))&&r.push(a);return r}function mr(e){if(!Or(e))return gr(e);var t=[];for(var r in Object(e))ae.call(e,r)&&r!="constructor"&&t.push(r);return t}function Ar(e,t){return t=t==null?Me:t,!!t&&(typeof e=="number"||ir.test(e))&&e>-1&&e%1==0&&e<t}function Or(e){var t=e&&e.constructor,r=typeof t=="function"&&t.prototype||H;return e===r}function _r(e,t,r,n){e=ie(e)?e:Mr(e),r=r&&!n?Er(r):0;var o=e.length;return r<0&&(r=br(o+r,0)),Sr(e)?r<=o&&e.indexOf(t,r)>-1:!!o&&ur(e,t,r)>-1}function jr(e){return kr(e)&&ae.call(e,"callee")&&(!hr.call(e,"callee")||W.call(e)==Zt)}var Ie=Array.isArray;function ie(e){return e!=null&&xr(e.length)&&!vr(e)}function kr(e){return oe(e)&&ie(e)}function vr(e){var t=ne(e)?W.call(e):"";return t==Xt||t==zt}function xr(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=Me}function ne(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}function oe(e){return!!e&&typeof e=="object"}function Sr(e){return typeof e=="string"||!Ie(e)&&oe(e)&&W.call(e)==Yt}function wr(e){return typeof e=="symbol"||oe(e)&&W.call(e)==er}function Tr(e){if(!e)return e===0?e:0;if(e=Cr(e),e===Ce||e===-Ce){var t=e<0?-1:1;return t*qt}return e===e?e:0}function Er(e){var t=Tr(e),r=t%1;return t===t?r?t-r:t:0}function Cr(e){if(typeof e=="number")return e;if(wr(e))return $e;if(ne(e)){var t=typeof e.valueOf=="function"?e.valueOf():e;e=ne(t)?t+"":t}if(typeof e!="string")return e===0?e:+e;e=e.replace(tr,"");var r=nr.test(e);return r||ar.test(e)?or(e.slice(2),r?2:8):rr.test(e)?$e:+e}function $r(e){return ie(e)?dr(e):mr(e)}function Mr(e){return e?lr(e,$r(e)):[]}Pe.exports=_r});var Ke=G((Ba,Ne)=>{var Ir=typeof global=="object"&&global&&global.Object===Object&&global,Pr=typeof self=="object"&&self&&self.Object===Object&&self,Dr=Ir||Pr||Function("return this")(),Br=Dr.isFinite;function Fr(e){return typeof e=="number"&&Br(e)}Ne.exports=Fr});var wt=G((F,E)=>{var Nr=200,Xe="__lodash_hash_undefined__",ze=9007199254740991,he="[object Arguments]",Kr="[object Array]",Ye="[object Boolean]",et="[object Date]",Rr="[object Error]",ge="[object Function]",tt="[object GeneratorFunction]",Q="[object Map]",rt="[object Number]",be="[object Object]",Re="[object Promise]",nt="[object RegExp]",q="[object Set]",at="[object String]",it="[object Symbol]",ce="[object WeakMap]",ot="[object ArrayBuffer]",Z="[object DataView]",st="[object Float32Array]",ct="[object Float64Array]",ut="[object Int8Array]",ft="[object Int16Array]",pt="[object Int32Array]",lt="[object Uint8Array]",yt="[object Uint8ClampedArray]",ht="[object Uint16Array]",gt="[object Uint32Array]",Lr=/[\\^$.*+?()[\]{}|]/g,Ur=/\w*$/,Gr=/^\[object .+?Constructor\]$/,Vr=/^(?:0|[1-9]\d*)$/,y={};y[he]=y[Kr]=y[ot]=y[Z]=y[Ye]=y[et]=y[st]=y[ct]=y[ut]=y[ft]=y[pt]=y[Q]=y[rt]=y[be]=y[nt]=y[q]=y[at]=y[it]=y[lt]=y[yt]=y[ht]=y[gt]=!0;y[Rr]=y[ge]=y[ce]=!1;var Hr=typeof global=="object"&&global&&global.Object===Object&&global,Wr=typeof self=="object"&&self&&self.Object===Object&&self,_=Hr||Wr||Function("return this")(),bt=typeof F=="object"&&F&&!F.nodeType&&F,Le=bt&&typeof E=="object"&&E&&!E.nodeType&&E,Jr=Le&&Le.exports===bt;function Qr(e,t){return e.set(t[0],t[1]),e}function qr(e,t){return e.add(t),e}function Zr(e,t){for(var r=-1,n=e?e.length:0;++r<n&&t(e[r],r,e)!==!1;);return e}function Xr(e,t){for(var r=-1,n=t.length,o=e.length;++r<n;)e[o+r]=t[r];return e}function dt(e,t,r,n){var o=-1,a=e?e.length:0;for(n&&a&&(r=e[++o]);++o<a;)r=t(r,e[o],o,e);return r}function zr(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function Yr(e,t){return e==null?void 0:e[t]}function mt(e){var t=!1;if(e!=null&&typeof e.toString!="function")try{t=!!(e+"")}catch(r){}return t}function Ue(e){var t=-1,r=Array(e.size);return e.forEach(function(n,o){r[++t]=[o,n]}),r}function de(e,t){return function(r){return e(t(r))}}function Ge(e){var t=-1,r=Array(e.size);return e.forEach(function(n){r[++t]=n}),r}var en=Array.prototype,tn=Function.prototype,X=Object.prototype,se=_["__core-js_shared__"],Ve=function(){var e=/[^.]+$/.exec(se&&se.keys&&se.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}(),At=tn.toString,k=X.hasOwnProperty,z=X.toString,rn=RegExp("^"+At.call(k).replace(Lr,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),He=Jr?_.Buffer:void 0,We=_.Symbol,Je=_.Uint8Array,nn=de(Object.getPrototypeOf,Object),an=Object.create,on=X.propertyIsEnumerable,sn=en.splice,Qe=Object.getOwnPropertySymbols,cn=He?He.isBuffer:void 0,un=de(Object.keys,Object),ue=M(_,"DataView"),N=M(_,"Map"),fe=M(_,"Promise"),pe=M(_,"Set"),le=M(_,"WeakMap"),K=M(Object,"create"),fn=T(ue),pn=T(N),ln=T(fe),yn=T(pe),hn=T(le),qe=We?We.prototype:void 0,Ze=qe?qe.valueOf:void 0;function w(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function gn(){this.__data__=K?K(null):{}}function bn(e){return this.has(e)&&delete this.__data__[e]}function dn(e){var t=this.__data__;if(K){var r=t[e];return r===Xe?void 0:r}return k.call(t,e)?t[e]:void 0}function mn(e){var t=this.__data__;return K?t[e]!==void 0:k.call(t,e)}function An(e,t){var r=this.__data__;return r[e]=K&&t===void 0?Xe:t,this}w.prototype.clear=gn;w.prototype.delete=bn;w.prototype.get=dn;w.prototype.has=mn;w.prototype.set=An;function j(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function On(){this.__data__=[]}function _n(e){var t=this.__data__,r=Y(t,e);if(r<0)return!1;var n=t.length-1;return r==n?t.pop():sn.call(t,r,1),!0}function jn(e){var t=this.__data__,r=Y(t,e);return r<0?void 0:t[r][1]}function kn(e){return Y(this.__data__,e)>-1}function vn(e,t){var r=this.__data__,n=Y(r,e);return n<0?r.push([e,t]):r[n][1]=t,this}j.prototype.clear=On;j.prototype.delete=_n;j.prototype.get=jn;j.prototype.has=kn;j.prototype.set=vn;function C(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function xn(){this.__data__={hash:new w,map:new(N||j),string:new w}}function Sn(e){return ee(this,e).delete(e)}function wn(e){return ee(this,e).get(e)}function Tn(e){return ee(this,e).has(e)}function En(e,t){return ee(this,e).set(e,t),this}C.prototype.clear=xn;C.prototype.delete=Sn;C.prototype.get=wn;C.prototype.has=Tn;C.prototype.set=En;function $(e){this.__data__=new j(e)}function Cn(){this.__data__=new j}function $n(e){return this.__data__.delete(e)}function Mn(e){return this.__data__.get(e)}function In(e){return this.__data__.has(e)}function Pn(e,t){var r=this.__data__;if(r instanceof j){var n=r.__data__;if(!N||n.length<Nr-1)return n.push([e,t]),this;r=this.__data__=new C(n)}return r.set(e,t),this}$.prototype.clear=Cn;$.prototype.delete=$n;$.prototype.get=Mn;$.prototype.has=In;$.prototype.set=Pn;function Dn(e,t){var r=Ae(e)||ia(e)?zr(e.length,String):[],n=r.length,o=!!n;for(var a in e)(t||k.call(e,a))&&!(o&&(a=="length"||ta(a,n)))&&r.push(a);return r}function Ot(e,t,r){var n=e[t];(!(k.call(e,t)&&vt(n,r))||r===void 0&&!(t in e))&&(e[t]=r)}function Y(e,t){for(var r=e.length;r--;)if(vt(e[r][0],t))return r;return-1}function Bn(e,t){return e&&_t(t,Oe(t),e)}function ye(e,t,r,n,o,a,i){var u;if(n&&(u=a?n(e,o,a,i):n(e)),u!==void 0)return u;if(!te(e))return e;var l=Ae(e);if(l){if(u=zn(e),!t)return qn(e,u)}else{var b=S(e),A=b==ge||b==tt;if(sa(e))return Un(e,t);if(b==be||b==he||A&&!a){if(mt(e))return a?e:{};if(u=Yn(A?{}:e),!t)return Zn(e,Bn(u,e))}else{if(!y[b])return a?e:{};u=ea(e,b,ye,t)}}i||(i=new $);var f=i.get(e);if(f)return f;if(i.set(e,u),!l)var s=r?Xn(e):Oe(e);return Zr(s||e,function(h,p){s&&(p=h,h=e[p]),Ot(u,p,ye(h,t,r,n,p,e,i))}),u}function Fn(e){return te(e)?an(e):{}}function Nn(e,t,r){var n=t(e);return Ae(e)?n:Xr(n,r(e))}function Kn(e){return z.call(e)}function Rn(e){if(!te(e)||na(e))return!1;var t=St(e)||mt(e)?rn:Gr;return t.test(T(e))}function Ln(e){if(!kt(e))return un(e);var t=[];for(var r in Object(e))k.call(e,r)&&r!="constructor"&&t.push(r);return t}function Un(e,t){if(t)return e.slice();var r=new e.constructor(e.length);return e.copy(r),r}function me(e){var t=new e.constructor(e.byteLength);return new Je(t).set(new Je(e)),t}function Gn(e,t){var r=t?me(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}function Vn(e,t,r){var n=t?r(Ue(e),!0):Ue(e);return dt(n,Qr,new e.constructor)}function Hn(e){var t=new e.constructor(e.source,Ur.exec(e));return t.lastIndex=e.lastIndex,t}function Wn(e,t,r){var n=t?r(Ge(e),!0):Ge(e);return dt(n,qr,new e.constructor)}function Jn(e){return Ze?Object(Ze.call(e)):{}}function Qn(e,t){var r=t?me(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}function qn(e,t){var r=-1,n=e.length;for(t||(t=Array(n));++r<n;)t[r]=e[r];return t}function _t(e,t,r,n){r||(r={});for(var o=-1,a=t.length;++o<a;){var i=t[o],u=n?n(r[i],e[i],i,r,e):void 0;Ot(r,i,u===void 0?e[i]:u)}return r}function Zn(e,t){return _t(e,jt(e),t)}function Xn(e){return Nn(e,Oe,jt)}function ee(e,t){var r=e.__data__;return ra(t)?r[typeof t=="string"?"string":"hash"]:r.map}function M(e,t){var r=Yr(e,t);return Rn(r)?r:void 0}var jt=Qe?de(Qe,Object):fa,S=Kn;(ue&&S(new ue(new ArrayBuffer(1)))!=Z||N&&S(new N)!=Q||fe&&S(fe.resolve())!=Re||pe&&S(new pe)!=q||le&&S(new le)!=ce)&&(S=function(e){var t=z.call(e),r=t==be?e.constructor:void 0,n=r?T(r):void 0;if(n)switch(n){case fn:return Z;case pn:return Q;case ln:return Re;case yn:return q;case hn:return ce}return t});function zn(e){var t=e.length,r=e.constructor(t);return t&&typeof e[0]=="string"&&k.call(e,"index")&&(r.index=e.index,r.input=e.input),r}function Yn(e){return typeof e.constructor=="function"&&!kt(e)?Fn(nn(e)):{}}function ea(e,t,r,n){var o=e.constructor;switch(t){case ot:return me(e);case Ye:case et:return new o(+e);case Z:return Gn(e,n);case st:case ct:case ut:case ft:case pt:case lt:case yt:case ht:case gt:return Qn(e,n);case Q:return Vn(e,n,r);case rt:case at:return new o(e);case nt:return Hn(e);case q:return Wn(e,n,r);case it:return Jn(e)}}function ta(e,t){return t=t==null?ze:t,!!t&&(typeof e=="number"||Vr.test(e))&&e>-1&&e%1==0&&e<t}function ra(e){var t=typeof e;return t=="string"||t=="number"||t=="symbol"||t=="boolean"?e!=="__proto__":e===null}function na(e){return!!Ve&&Ve in e}function kt(e){var t=e&&e.constructor,r=typeof t=="function"&&t.prototype||X;return e===r}function T(e){if(e!=null){try{return At.call(e)}catch(t){}try{return e+""}catch(t){}}return""}function aa(e){return ye(e,!0,!0)}function vt(e,t){return e===t||e!==e&&t!==t}function ia(e){return oa(e)&&k.call(e,"callee")&&(!on.call(e,"callee")||z.call(e)==he)}var Ae=Array.isArray;function xt(e){return e!=null&&ca(e.length)&&!St(e)}function oa(e){return ua(e)&&xt(e)}var sa=cn||pa;function St(e){var t=te(e)?z.call(e):"";return t==ge||t==tt}function ca(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=ze}function te(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}function ua(e){return!!e&&typeof e=="object"}function Oe(e){return xt(e)?Dn(e):Ln(e)}function fa(){return[]}function pa(){return!1}E.exports=aa});var It=G((R,I)=>{var la="[object Date]",ya=typeof global=="object"&&global&&global.Object===Object&&global,Mt=typeof R=="object"&&R&&!R.nodeType&&R,Tt=Mt&&typeof I=="object"&&I&&!I.nodeType&&I,ha=Tt&&Tt.exports===Mt,Et=ha&&ya.process,Ct=function(){try{return Et&&Et.binding("util")}catch(e){}}(),$t=Ct&&Ct.isDate;function ga(e){return function(t){return e(t)}}var ba=Object.prototype,da=ba.toString;function ma(e){return Oa(e)&&da.call(e)==la}var Aa=$t?ga($t):ma;function Oa(e){return!!e&&typeof e=="object"}I.exports=Aa});var Ca={};Jt(Ca,{defaults:()=>Kt,generateAst:()=>Ea,version:()=>wa});var Bt=V(De(),1);function d(e){if(e==null||typeof e!="object")return!1;let t=Object.getPrototypeOf(e);return t!==null&&t!==Object.prototype&&Object.getPrototypeOf(t)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function D(e){return typeof e=="string"}function Be(e){return Number.isFinite(e)}function J(e){return typeof e=="boolean"}function B(e){return e!=null}function Fe(e,t){return d(e)&&D(t)&&Object.prototype.hasOwnProperty.call(e,t)}function O(e){return e==null?!1:Array.isArray(e)||typeof e=="string"?!!e.length:d(e)?!!Object.keys(e).length:typeof e=="number"}var ve=V(Ke(),1),c=V(wt(),1),L=V(It(),1);function _e(e){if(typeof e!="string")throw new TypeError("Expected a string");return e.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var je=new Map,Pt=(e,t)=>{if(!Array.isArray(e))switch(typeof e){case"string":e=[e];break;case"undefined":e=[];break;default:throw new TypeError(`Expected '${t}' to be a string or an array, but got a type of '${typeof e}'`)}return e.filter(r=>{if(typeof r!="string"){if(typeof r>"u")return!1;throw new TypeError(`Expected '${t}' to be an array of strings, but found a type of '${typeof r}' in the array`)}return!0})},_a=(e,t)=>{t=m({caseSensitive:!1},t);let r=e+JSON.stringify(t);if(je.has(r))return je.get(r);let n=e[0]==="!";n&&(e=e.slice(1)),e=_e(e).replace(/\\\*/g,"[\\s\\S]*");let o=new RegExp(`^${e}$`,t.caseSensitive?"":"i");return o.negated=n,je.set(r,o),o},ja=(e,t,r,n)=>{if(e=Pt(e,"inputs"),t=Pt(t,"patterns"),t.length===0)return[];t=t.map(i=>_a(i,r));let{allPatterns:o}=r||{},a=[];for(let i of e){let u,l=[...t].fill(!1);for(let[b,A]of t.entries())if(A.test(i)&&(l[b]=!0,u=!A.negated,!u))break;if(!(u===!1||u===void 0&&t.some(b=>!b.negated)||o&&l.some((b,A)=>!b&&!t[A].negated))&&(a.push(i),n))break}return a};function re(e,t,r){return ja(e,t,r,!0).length>0}var ka={arrayVsArrayAllMustBeFound:"any",caseSensitive:!0};function ke(e,t,r){if(!e.length||!t.length)return!1;let n=m(m({},ka),r),o=typeof e=="string"?[e]:Array.from(e);return typeof t=="string"?o.some(a=>re(a,t,{caseSensitive:n.caseSensitive})):n.arrayVsArrayAllMustBeFound==="any"?t.some(a=>o.some(i=>re(i,a,{caseSensitive:n.caseSensitive}))):t.every(a=>o.some(i=>re(i,a,{caseSensitive:n.caseSensitive})))}var v=Array.isArray;function Dt(e){return!!e&&e.some(t=>typeof t=="string")}function va(e,t){return Object.keys(e).length===0||Object.keys(t).length===0||Object.keys(e).every(r=>Object.keys(t).includes(r))||Object.keys(t).every(r=>Object.keys(e).includes(r))}function g(e){return e===null?"null":(0,L.default)(e)?"date":d(e)?"object":v(e)?"array":typeof e}var xa={cb:null,mergeObjectsOnlyWhenKeysetMatches:!0,ignoreKeys:[],hardMergeKeys:[],hardArrayConcatKeys:[],mergeArraysContainingStringsToBeEmpty:!1,oneToManyArrayObjectMerge:!1,hardMergeEverything:!1,hardArrayConcat:!1,ignoreEverything:!1,concatInsteadOfMerging:!0,dedupeStringsInArrayValues:!1,mergeBoolsUsingOrNotAnd:!0,useNullAsExplicitFalse:!1};function x(e,t,r,n){var A;let o;if(n.useNullAsExplicitFalse&&(t===null||r===null))return typeof n.cb=="function"?n.cb(t,r,null,{path:e.path,key:e.key,type:e.type}):null;let a=v(t)||d(t)?(0,c.default)(t):t,i=v(r)||d(r)?(0,c.default)(r):r,u;n.ignoreEverything?u=a:n.hardMergeEverything&&(u=i);let l=n.hardMergeEverything||n.ignoreEverything;if(v(a))if(O(a))if(v(i)&&O(i)){if(n.mergeArraysContainingStringsToBeEmpty&&(Dt(a)||Dt(i))){let s=l?u:[];return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:o,key:e.key,type:e.type}):s}if(n.hardArrayConcat){let s=l?u:a.concat(i);return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:o,key:e.key,type:e.type}):s}let f=[];for(let s=0,h=Math.max(a.length,i.length);s<h;s++)o=(A=e.path)!=null&&A.length?`${e.path}.${s}`:`${s}`,d(a[s])&&d(i[s])&&(n.mergeObjectsOnlyWhenKeysetMatches&&va(a[s],i[s])||!n.mergeObjectsOnlyWhenKeysetMatches)?f.push(x({path:o,key:e.key,type:[g(a),g(i)]},a[s],i[s],n)):n.oneToManyArrayObjectMerge&&(a.length===1||i.length===1)?f.push(a.length===1?x({path:o,key:e.key,type:[g(a),g(i)]},a[0],i[s],n):x({path:o,key:e.key,type:[g(a),g(i)]},a[s],i[0],n)):n.concatInsteadOfMerging?(s<a.length&&f.push(a[s]),s<i.length&&f.push(i[s])):(s<a.length&&f.push(a[s]),s<i.length&&!(0,Bt.default)(a,i[s])&&f.push(i[s]));n.dedupeStringsInArrayValues&&f.every(s=>D(s))&&(f=[...new Set(f)].sort()),a=(0,c.default)(f)}else{let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:o,key:e.key,type:e.type}):f}else{if(O(i)){let s=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:o,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:o,key:e.key,type:e.type}):f}else if(d(a)){if(O(a)){if(v(i)){if(O(i)){let p=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),p,{path:o,key:e.key,type:e.type}):p}let h=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:o,key:e.key,type:e.type}):h}if(d(i)){Object.keys(i).forEach(p=>{var xe;o=(xe=e.path)!=null&&xe.length?`${e.path}.${p}`:`${p}`,Fe(a,p)?ke(p,n.ignoreKeys)?a[p]=x({path:o,key:p,type:[g(a),g(i)]},a[p],i[p],U(m({},n),{ignoreEverything:!0})):ke(p,n.hardMergeKeys)?a[p]=x({path:o,key:p,type:[g(a),g(i)]},a[p],i[p],U(m({},n),{hardMergeEverything:!0})):ke(p,n.hardArrayConcatKeys)?a[p]=x({path:o,key:p,type:[g(a),g(i)]},a[p],i[p],U(m({},n),{hardArrayConcat:!0})):a[p]=x({path:o,key:p,type:[g(a[p]),g(i[p])]},a[p],i[p],n):a[p]=i[p]});let h=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):a}let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(v(i)||d(i)||O(i)){let s=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if((0,L.default)(a)){if((0,ve.default)(+a)){if((0,L.default)(i)){if((0,ve.default)(+i)){let p=l?u:a>i?a:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),p,{path:e.path,key:e.key,type:e.type}):p}let h=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?u:i||a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if((0,L.default)(i)){let s=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(D(a)){if(O(a)){if((v(i)||d(i)||D(i))&&O(i)){let h=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(B(i)&&!J(i)){let s=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(Be(a)){if(O(i)){let s=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(J(a)){if(J(i)){if(n.mergeBoolsUsingOrNotAnd){let h=l?u:a||i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?u:a&&i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(B(i)){let s=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(a===null){if(B(i)){let s=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else{let f=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}let b=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),b,{path:e.path,key:e.key,type:e.type}):b}function Ft(e,t,r){var o,a;if(!arguments.length)throw new TypeError("object-merge-advanced/mergeAdvanced(): [THROW_ID_01] Both inputs are missing");if(B(r)&&!d(r))throw new TypeError(`object-merge-advanced/mergeAdvanced(): [THROW_ID_02] The optional options object should be a plain object, currently it's ${JSON.stringify(r,null,4)} (type ${typeof r})`);let n=m(m({},xa),r);return typeof n.ignoreKeys=="string"&&(n.ignoreKeys=[n.ignoreKeys]),typeof n.hardMergeKeys=="string"&&(n.hardMergeKeys=[n.hardMergeKeys]),(o=n==null?void 0:n.hardMergeKeys)!=null&&o.includes("*")&&(n.hardMergeEverything=!0),(a=n==null?void 0:n.ignoreKeys)!=null&&a.includes("*")&&(n.ignoreEverything=!0),x({key:null,path:"",type:[g(e),g(t)]},e,t,n)}var Nt="4.0.10";var wa=Nt,Kt={dedupe:!0};function Ta(e){return Object.keys(e).sort().reduce((t,r)=>(t[r]=e[r],t),{})}function Ea(e,t){if(Array.isArray(e)){if(e.length===0)return{}}else throw new Error(`array-of-arrays-into-ast: [THROW_ID_01] inputArr must be array. Currently it's of a type ${typeof e} equal to:
${JSON.stringify(e,null,4)}`);let r=m(m({},Kt),t),n={};return e.forEach(o=>{let a=null;for(let i=o.length;i--;)a={[o[i]]:[a]};n=Ft(n,a,{concatInsteadOfMerging:!r.dedupe})}),Ta(n)}return Qt(Ca);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.3.1
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name util-nonempty
 * @fileoverview Is the input (plain object, array, string or whatever) not empty?
 * @version 5.0.8
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/util-nonempty/}
 */
/**
 * @name object-merge-advanced
 * @fileoverview Deeply merge JSON-like data structures
 * @version 14.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/object-merge-advanced/}
 */
